SystemOrganization addCategory: #'Magritte-Core-Description'!
SystemOrganization addCategory: #'Magritte-Core-Comparators'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Utilities'!
SystemOrganization addCategory: #'Magritte-Core-Tests'!

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:44'!
realSubject
	^super realSubject value.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 1/1/2005 15:58'!
on: anObject
	^self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 2/28/2005 16:05'!
doesNotUnderstand: aMessage
	^self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 2/28/2005 16:05'!
isNil
	^self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printString
	^String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject
	^realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject: anObject
	realSubject := anObject! !

!UndefinedObject methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'n/a'! !

Error subclass: #MAError
	instanceVariableNames: 'resumeable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAError class methodsFor: 'instance creation' stamp: 'lr 3/14/2005 17:00'!
description: aDescription message: aString
	^self description: aDescription message: aString resumeable: false.! !

!MAError class methodsFor: 'instance creation' stamp: 'lr 3/14/2005 16:52'!
description: aDescription message: aString resumeable: aBoolean
	^self new
		tag: aDescription;
		resumeable: aBoolean;
		signal: aString.! !

!MAError methodsFor: 'testing' stamp: 'lr 3/14/2005 16:51'!
isResumeable
	^self resumeable.! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/14/2005 16:51'!
resumeable
	^resumeable! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/14/2005 16:51'!
resumeable: aBoolean
	resumeable := aBoolean! !

MAError subclass: #MAReadonlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAError subclass: #MARequiredError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAError subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!False methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'no'! !

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:55'!
default
	default isNil
		ifTrue: [ default := self new ].
	^default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 11:22'!
buildFor: anObject
	^anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each)
				ifTrue: [ container append: (anObject perform: each) ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 3/9/2005 22:42'!
isDescriptionSelector: aSelector
	^aSelector isUnary 
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 11:22'!
buildFor: anObject
	^self cache
		at: anObject
		ifAbsentPut: [ super buildFor: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache
	^cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 10:56'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 10:56'!
initialize
	super initialize.
	self flush.! !

Object subclass: #MAComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MAComparator methodsFor: 'comparing' stamp: 'lr 3/16/2005 14:00'!
compare: leftObject with: rightObject
	self subclassResponsibility.! !

MAComparator subclass: #MAEqualsComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MAEqualsComparator methodsFor: 'converting' stamp: 'lr 3/16/2005 15:19'!
asLabel
	^'equals'! !

!MAEqualsComparator methodsFor: 'comparing' stamp: 'lr 3/16/2005 14:03'!
compare: leftObject with: rightObject
	^leftObject = rightObject.! !

MAComparator subclass: #MAGreaterThanComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MAGreaterThanComparator methodsFor: 'converting' stamp: 'lr 3/16/2005 15:47'!
asLabel
	^ 'greater than'! !

!MAGreaterThanComparator methodsFor: 'comparing' stamp: 'lr 3/16/2005 15:47'!
compare: leftObject with: rightObject
	^[ leftObject > rightObject ]
		ifError: [ false ].! !

MAComparator subclass: #MALessThanComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MALessThanComparator methodsFor: 'converting' stamp: 'lr 3/16/2005 15:47'!
asLabel
	^ 'less than'! !

!MALessThanComparator methodsFor: 'comparing' stamp: 'lr 3/16/2005 15:47'!
compare: leftObject with: rightObject
	^[ leftObject < rightObject ]
		ifError: [ false ].! !

MAComparator subclass: #MANotEqualsComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MANotEqualsComparator methodsFor: 'converting' stamp: 'lr 3/16/2005 15:20'!
asLabel
	^ 'not equals'! !

!MANotEqualsComparator methodsFor: 'comparing' stamp: 'lr 3/16/2005 14:03'!
compare: leftObject with: rightObject
	^leftObject ~= rightObject.! !

Object subclass: #MADescription
	instanceVariableNames: 'key label priority properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAContainer class methodsFor: 'testing' stamp: 'lr 3/10/2005 22:52'!
isConcrete
	^true! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
add: aDescription
	self remove: aDescription.
	self children add: aDescription.! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
append: anObject
	(anObject isKindOf: MADescription)
		ifTrue: [ self add: anObject ]
		ifFalse: [ 
			anObject isCollection
				ifTrue: [ self addAll: anObject ] ].! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
at: aSymbol
	^children detect: [ :each | aSymbol = each key ].! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
at: aSymbol ifAbsent: aBlock
	^children detect: [ :each | aSymbol = each key ] ifNone: aBlock.! !

!MAContainer methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
children
	^children! !

!MAContainer methodsFor: 'accessing-configuration' stamp: 'lr 3/11/2005 11:30'!
defaultChildCollection
	^OrderedCollection new.! !

!MAContainer methodsFor: 'enumeration' stamp: 'lr 3/10/2005 10:52'!
do: aBlock
	self children do: aBlock.! !

!MAContainer methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 10:53'!
initialize
	super initialize.
	children := self defaultChildCollection.! !

!MAContainer methodsFor: 'copying' stamp: 'lr 3/10/2005 10:53'!
postCopy
	super postCopy.
	children := self defaultChildCollection 
		addAll: (self children collect: [ :each | each copy ]);
		yourself.! !

!MAContainer methodsFor: 'enumeration' stamp: 'lr 3/11/2005 09:48'!
reject: aBlock
	^self select: [ :each | (aBlock value: each) not ].! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ ].! !

!MAContainer methodsFor: 'modification' stamp: 'lr 3/11/2005 09:40'!
removeAll
	children := self defaultChildCollection.! !

!MAContainer methodsFor: 'enumeration' stamp: 'lr 3/11/2005 09:40'!
select: aBlock
	^self copy
		removeAll;
		addAll: (self children 
			select: aBlock);
		yourself.! !

MAContainer subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPriorityContainer methodsFor: 'accessing-configuration' stamp: 'lr 3/11/2005 11:30'!
defaultChildCollection
	^SortedCollection sortBlock: [ :a :b | a priority <= b priority ].! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:17'!
defaultKey
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:33'!
defaultLabel
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:27'!
defaultPriority
	^0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:23'!
defaultReadonly
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/11/2005 20:39'!
defaultRequired
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:18'!
defaultTitle
	^super defaultTitle allButFirst: 2.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:28'!
defaultVisible
	^true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 11:17'!
descriptionKey
	^MASymbol key: #key label: 'Key' priority: 100 default: self defaultKey.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 11:17'!
descriptionLabel
	^MAString key: #label label: 'Label' priority: 110 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 10:29'!
descriptionPriority
	^MANumber key: #priority label: 'Priority' priority: 120 default: self defaultPriority.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 22:49'!
descriptionReadonly
	^MABoolean key: #readonly label: 'Readonly' priority: 200 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/11/2005 20:32'!
descriptionRequired
	^MABoolean key: #required label: 'Required' priority: 220 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 22:49'!
descriptionVisible
	^MABoolean key: #visible label: 'Visible' priority: 210 default: self defaultVisible.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 3/10/2005 22:52'!
isConcrete
	^false! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey
	^self key: aKey label: aKey asString.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey label: aString
	^self key: aKey label: aString priority: self defaultPriority.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey label: aString priority: aNumber
	^self new
		key: aKey;
		label: aString;
		priority: aNumber;
		readonly: self defaultReadonly;
		visible: self defaultVisible;
		yourself.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/9/2005 18:29'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isConcrete
		ifFalse: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MADescription methodsFor: 'converting' stamp: 'lr 3/16/2005 15:25'!
asLabel
	^self label.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:31'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:25'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'initialize-release' stamp: 'lr 3/9/2005 17:58'!
initialize
	super initialize.
	properties := Dictionary new.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isReadonly
	^self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/11/2005 20:31'!
isRequired
	^self required.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isVisible
	^self visible.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
key
	^key! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
key: anObject
	key := anObject! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
label
	^label! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
label: aString
	label := aString! !

!MADescription methodsFor: 'copying' stamp: 'lr 3/10/2005 10:54'!
postCopy
	super postCopy.
	properties := properties copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 3/10/2005 10:50'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' key: '; print: self key.
	aStream nextPutAll: ' label: '; print: self label.
	aStream nextPutAll: ' priority: '; print: self priority.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:09'!
priority
	^priority! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:09'!
priority: aNumber
	priority := aNumber! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
properties
	^properties! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:13'!
propertyAt: aKey
	^self properties at: aKey.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
propertyAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsentPut: aBlock.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
propertyAt: aKey put: aValue
	self properties at: aKey put: aValue.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:13'!
propertyIncludes: aKey
	^self properties includesKey: aKey.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
readonly	
	^self 
		propertyAt: #readonly 
		ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/11/2005 20:24'!
required	
	^self 
		propertyAt: #required 
		ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/11/2005 20:24'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
visible	
	^self 
		propertyAt: #visible 
		ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:11'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MADescription subclass: #MAElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElement subclass: #MABinary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABinary class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:42'!
defaultTitle
	^'Upload Field'! !

!MABinary class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 21:39'!
descriptionDefault
	^nil! !

!MABinary class methodsFor: 'testing' stamp: 'lr 3/10/2005 10:35'!
isConcrete
	^true! !

!MABinary methodsFor: 'testing' stamp: 'lr 3/11/2005 22:03'!
includes: anObject
	^anObject isKindOf: ByteArray.! !

!MABinary methodsFor: 'converting' stamp: 'lr 3/15/2005 21:41'!
parseString: aString
	^self parseString: aString protected: [ ByteArray withAll: aString ].! !

MAElement subclass: #MABoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABoolean class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:48'!
defaultDefault
	^false! !

!MABoolean class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:24'!
defaultTitle
	^'Check-Box'! !

!MABoolean class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MABoolean methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABoolean methodsFor: 'testing' stamp: 'lr 3/11/2005 21:41'!
includes: anObject
	^anObject isKindOf: Boolean.! !

!MABoolean methodsFor: 'converting' stamp: 'lr 3/14/2005 16:10'!
parseString: aString
	^self parseString: aString protected: [
		(self trueStrings includes: aString)
			ifTrue: [ ^true ].
		(self falseStrings includes: aString)
			ifTrue: [ ^false ].
		aString ].! !

!MABoolean methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

MAElement subclass: #MADate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADate class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:43'!
defaultTitle
	^'Date Field'! !

!MADate class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MADate methodsFor: 'testing' stamp: 'lr 3/11/2005 21:33'!
includes: anObject
	^anObject isKindOf: Date.! !

!MADate methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ Date fromString: aString ].! !

MAElement subclass: #MADuration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADuration class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:26'!
defaultTitle
	^'Duration Field'! !

!MADuration class methodsFor: 'testing' stamp: 'lr 3/15/2005 21:48'!
isConcrete
	^true! !

!MADuration methodsFor: 'testing' stamp: 'lr 3/15/2005 21:42'!
includes: anObject
	^anObject isKindOf: Duration.! !

!MADuration methodsFor: 'converting' stamp: 'lr 3/15/2005 21:42'!
parseString: aString
	^self parseString: aString protected: [ Duration fromString: aString ].! !

!MAElement class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 11:48'!
defaultDefault
	^nil! !

!MAElement class methodsFor: 'accessing-description' stamp: 'lr 3/10/2005 22:50'!
descriptionDefault
	^self isConcrete 
		ifTrue: [ self key: #default label: 'Default' priority: 130 default: self defaultDefault ].! !

!MAElement class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:09'!
key: aKey label: aString priority: aNumber
	^(super key: aKey label: aString priority: aNumber)
		default: self defaultDefault;
		yourself.! !

!MAElement class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:09'!
key: aKey label: aString priority: aNumber default: aValue
	^(self key: aKey label: aString priority: aNumber)
		default: aValue;
		yourself.! !

!MAElement methodsFor: 'private' stamp: 'lr 3/15/2005 08:54'!
collectionToString: aCollection
	^String streamContents: [ :stream |
		aCollection
			do: [ :each | stream nextPutAll: each asString ]
			separatedBy: [ stream cr ] ].! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/16/2005 14:06'!
comparators
	^Array with: MAEqualsComparator with: MANotEqualsComparator.! !

!MAElement methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:40'!
default
	^self 
		propertyAt: #default 
		ifAbsent: [ self class defaultDefault ].! !

!MAElement methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:41'!
default: anObject
	self propertyAt: #default put: anObject.! !

!MAElement methodsFor: 'private-errors' stamp: 'lr 3/14/2005 11:17'!
errorReadonly
	MAReadonlyError 
		description: self 
		message: self label , ' is readonly.'.! !

!MAElement methodsFor: 'private-errors' stamp: 'lr 3/14/2005 11:17'!
errorRequired
	MARequiredError 
		description: self 
		message: self label , ' is required.'.! !

!MAElement methodsFor: 'private-errors' stamp: 'lr 3/14/2005 16:36'!
errorValidation
	MAValidationError 
		description: self 
		message:  self label , ' is invalid.'.! !

!MAElement methodsFor: 'testing' stamp: 'lr 3/14/2005 11:07'!
includes: anObject
	"Return true or false wether anObject is a proper value of the receiver."

	self subclassResponsibility.! !

!MAElement methodsFor: 'converting' stamp: 'lr 3/14/2005 16:12'!
migrate: anObject from: aDescription
	^self parseString: (aDescription toString: anObject).! !

!MAElement methodsFor: 'converting' stamp: 'lr 3/14/2005 16:15'!
parseString: aString
	^self parseString: aString protected: [ aString ].! !

!MAElement methodsFor: 'converting' stamp: 'lr 3/14/2005 16:15'!
parseString: aString protected: aBlock
	^aString isEmptyOrNil ifFalse: [ 
		aBlock
			on: Error
			do: [ :err | err return: aString ] ].! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/14/2005 11:46'!
read: aModel
	"Read from aModel using the receiver as description."
	
	^(aModel readUsing: self)
		ifNil: [ self default ].! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 15:53'!
readSelector	
	^self key asSymbol.! !

!MAElement methodsFor: 'private' stamp: 'lr 3/15/2005 23:18'!
stringToCollection: aString default: aCollection
	^aString isEmptyOrNil
		ifTrue: [ aCollection ]
		ifFalse: [
			aString withBlanksCondensed 
				findTokens: Character cr ].! !

!MAElement methodsFor: 'converting' stamp: 'lr 3/13/2005 20:51'!
toString: anObject
	^anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asString ].! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/14/2005 11:13'!
validate: anObject
	"Check if anObject can be written to the model described by the receiver. In case of problems an exception is raised."

	(self isRequired and: [ anObject isNil ])
		ifTrue: [ self errorRequired ].
	(anObject isNil or: [ self includes: anObject ])
		ifFalse: [ self errorValidation ].! !

!MAElement methodsFor: 'testing' stamp: 'lr 3/14/2005 11:09'!
validates: anObject
	[ self validate: anObject ] 
		on: Error 
		do: [ :err | ^false ].
	^true.! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/14/2005 11:14'!
write: anObject to: aModel
	"Write to aModel using the receiver as description and anObject as value."

	self isReadonly
		ifTrue: [ self errorReadonly ]
		ifFalse: [ self validate: anObject ].
	^aModel write: anObject using: self.! !

!MAElement methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 15:53'!
writeSelector	
	^(self key copyWith: $:) 
		asSymbol.! !

MAElement subclass: #MANumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MANumber class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:43'!
defaultTitle
	^'Number Field'! !

!MANumber class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MANumber methodsFor: 'accessing-model' stamp: 'lr 3/16/2005 15:48'!
comparators
	^super comparators , (Array with: MAGreaterThanComparator with: MALessThanComparator).! !

!MANumber methodsFor: 'testing' stamp: 'lr 3/11/2005 21:33'!
includes: anObject
	^anObject isKindOf: Number.! !

!MANumber methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asNumber ].! !

MAElement subclass: #MAOptions
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAOptions class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:38'!
defaultOptions
	^OrderedCollection new.! !

!MAOptions class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:24'!
defaultTitle
	^'Option-Box'! !

!MAOptions class methodsFor: 'accessing-description' stamp: 'lr 3/14/2005 12:16'!
descriptionDefault
	^nil! !

!MAOptions class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 18:38'!
descriptionOptions
	^MAText key: #optionsTextual label: 'Options' priority: 140.! !

!MAOptions class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:34'!
isConcrete
	^true! !

!MAOptions methodsFor: 'testing' stamp: 'lr 3/11/2005 22:38'!
includes: anObject
	^self options includes: anObject.! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/14/2005 19:22'!
options
	options isNil
		ifTrue: [ self options: self class defaultOptions ].
	^options.! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/11/2005 22:37'!
options: aCollection
	options := aCollection! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/15/2005 18:38'!
optionsTextual
	^self collectionToString: self options.! !

!MAOptions methodsFor: 'accessing' stamp: 'lr 3/15/2005 18:38'!
optionsTextual: aString
	self options: (self stringToCollection: aString default: self class defaultOptions).! !

!MAOptions methodsFor: 'copying' stamp: 'lr 3/11/2005 22:36'!
postCopy
	super postCopy.
	self options: self options copy.! !

MAElement subclass: #MAString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAString subclass: #MAPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAPassword class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:24'!
defaultTitle
	^'Password Field'! !

!MAPassword methodsFor: 'testing' stamp: 'lr 3/14/2005 14:09'!
isObfuscated: aString
	^aString notNil and: [ aString allSatisfy: [ :each | each = $* ] ].! !

!MAPassword methodsFor: 'converting' stamp: 'lr 3/11/2005 21:46'!
obfuscated: aString
	^aString isEmptyOrNil
		ifFalse: [ Array new: aString size withAll: $* ].! !

!MAString class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 11:47'!
defaultDefault
	^String new.! !

!MAString class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:24'!
defaultTitle
	^'Text Field'! !

!MAString class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

!MAString methodsFor: 'testing' stamp: 'lr 3/11/2005 21:34'!
includes: anObject
	^anObject isKindOf: String.! !

MAString subclass: #MASymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASymbol class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:25'!
defaultTitle
	^'Symbol Field'! !

!MASymbol methodsFor: 'testing' stamp: 'lr 3/11/2005 21:34'!
includes: anObject
	^anObject isKindOf: Symbol.! !

!MASymbol methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asSymbol ].! !

MAString subclass: #MAText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAText class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:25'!
defaultTitle
	^'Memo Field'! !

MAElement subclass: #MATable
	instanceVariableNames: 'rowLabels columnLabels descriptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATable class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultColumnLabels
	^OrderedCollection new! !

!MATable class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultDefault
	^Array new! !

!MATable class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:00'!
defaultDescriptionClass
	^MAString! !

!MATable class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultRowLables
	^OrderedCollection new! !

!MATable class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:25'!
defaultTitle
	^'Table'! !

!MATable class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 22:35'!
descriptionColumnLabels
	^MAText key: #columnLabelsTextual label: 'Column Labels' priority: 300.! !

!MATable class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:06'!
descriptionDefault
	^nil! !

!MATable class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 22:54'!
descriptionDescriptionClass
	^(MAOptions key: #descriptionClass label: 'Type' priority: 320)
		options: (Array with: MAString with: MAText with: MANumber with: MABoolean);
		yourself.! !

!MATable class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:20'!
descriptionRequired
	^nil! !

!MATable class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:20'!
descriptionRowLabels
	^MAText key: #rowLabelsTextual label: 'Row Labels' priority: 310.! !

!MATable class methodsFor: 'testing' stamp: 'lr 3/15/2005 09:00'!
isConcrete
	^true! !

!MATable methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:38'!
columnCount
	^self columnLabels size.! !

!MATable methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels
	columnLabels isNil 
		ifTrue: [ self columnLabels: self class defaultColumnLabels ].
	^columnLabels.! !

!MATable methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels: aCollection
	columnLabels := aCollection! !

!MATable methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual
	^self collectionToString: self columnLabels.! !

!MATable methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual: aString
	^self columnLabels: (self stringToCollection: aString default: self class defaultColumnLabels).! !

!MATable methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:04'!
descriptionClass
	descriptionClass isNil
		ifTrue: [ self descriptionClass: self class defaultDescriptionClass ].
	^descriptionClass.! !

!MATable methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:01'!
descriptionClass: aClass
	descriptionClass := aClass.! !

!MATable methodsFor: 'testing' stamp: 'lr 3/15/2005 09:41'!
includes: anObject
	^anObject isKindOf: SequenceableCollection.! !

!MATable methodsFor: 'copying' stamp: 'lr 3/16/2005 15:04'!
postCopy
	super postCopy.
	self rowLabels: self rowLabels copy.
	self columnLabels: self columnLabels copy.! !

!MATable methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:11'!
rowCount
	^self rowLabels size.! !

!MATable methodsFor: 'accessing' stamp: 'lr 3/15/2005 09:06'!
rowLabels
	rowLabels isNil 
		ifTrue: [ self rowLabels: self class defaultRowLables ].
	^rowLabels.! !

!MATable methodsFor: 'accessing' stamp: 'lr 3/15/2005 08:50'!
rowLabels: aCollection
	rowLabels := aCollection! !

!MATable methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:56'!
rowLabelsTextual
	^self collectionToString: self rowLabels.! !

!MATable methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:57'!
rowLabelsTextual: aString
	^self rowLabels: (self stringToCollection: aString default: self class defaultRowLables).! !

MAElement subclass: #MATime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATime class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:25'!
defaultTitle
	^'Time Field'! !

!MATime class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:15'!
isConcrete
	^true! !

!MATime methodsFor: 'testing' stamp: 'lr 3/11/2005 21:34'!
includes: anObject
	^anObject isKindOf: Time.! !

!MATime methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ Time fromString: aString ].! !

MAElement subclass: #MATimeStamp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATimeStamp class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:26'!
defaultTitle
	^'Timestamp Field'! !

!MATimeStamp class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:11'!
isConcrete
	^true! !

!MATimeStamp methodsFor: 'testing' stamp: 'lr 3/11/2005 21:35'!
includes: anObject
	^anObject isKindOf: TimeStamp.! !

!MATimeStamp methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ TimeStamp fromString: aString ].! !

Object subclass: #MAMockModel
	instanceVariableNames: 'values description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAMockModel methodsFor: 'private' stamp: 'lr 3/15/2005 21:37'!
buildDescription
	^self class description copy in: [ :container |
		MAElement allSubclassesDo: [ :class |
			class isConcrete ifTrue: [ 
				container add: (class 
					key: class name 
					label: class description label) ] ].
		container ].! !

!MAMockModel methodsFor: 'accessing' stamp: 'lr 3/10/2005 14:57'!
description
	description isNil
		ifTrue: [ description := self buildDescription ].
	^description.! !

!MAMockModel methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 14:50'!
readUsing: aDescription
	^self values 
		at: aDescription key 
		ifAbsent: [ nil ].! !

!MAMockModel methodsFor: 'accessing' stamp: 'lr 3/10/2005 16:54'!
values
	values isNil
		ifTrue: [ values := Dictionary new ].
	^values.! !

!MAMockModel methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 14:50'!
write: anObject using: aDescription
	self values 
		at: aDescription key
		put: anObject.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/11/2005 11:31'!
defaultContainer
	"Return the default description container."
	
	^MAPriorityContainer
		key: #yourself
		label: self defaultTitle.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 11:18'!
defaultTitle
	"Return the title of this class to be used in the description."
	
	^self name asString.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 10:38'!
description
	^MACachedBuilder default buildFor: self.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:20'!
asLabel
	^self asString.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/9/2005 22:24'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^self class description.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:39'!
readUsing: aDescription
	^self perform: aDescription readSelector.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 10:48'!
write: anObject using: aDescription
	self perform: aDescription writeSelector with: anObject.! !

!True methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'yes'! !

TestCase subclass: #MAAbstractDescriptionTest
	instanceVariableNames: 'value other description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAAbstractDescriptionTest class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:46'!
isAbstract
	^super isAbstract
		or: [ self name includesSubString: 'Abstract' ].! !

!MAAbstractDescriptionTest class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:47'!
shouldInheritSelectors
	^true! !

!MAAbstractDescriptionTest methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:44'!
description
	^description! !

!MAAbstractDescriptionTest methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:44'!
description: anObject
	description := anObject! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:48'!
descriptionClass
	self subclassResponsibility.! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	self subclassResponsibility.! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/14/2005 11:12'!
invalidElement
	^Object new! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/14/2005 11:12'!
nullElement
	^nil! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/14/2005 16:09'!
nullString
	^String new.! !

!MAAbstractDescriptionTest methodsFor: 'running' stamp: 'lr 3/14/2005 10:45'!
setUp
	self description: (self descriptionClass key: #value).! !

!MAAbstractDescriptionTest methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:27'!
value
	^value! !

!MAAbstractDescriptionTest methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:27'!
value: anObject
	value := anObject! !

MAAbstractDescriptionTest subclass: #MAAbstractElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 10:42'!
testDefault
	description default: #foo.
	self assert: description default = #foo.
	
	! !

!MAAbstractElementTest methodsFor: 'testing-testing' stamp: 'lr 3/14/2005 11:12'!
testIncludes
	self assert: (self description includes: self includedElement).
	self deny: (self description includes: self invalidElement).
	self deny: (self description includes: self nullElement).! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 11:24'!
testKey
	description key: #foo.
	self assert: description key = #foo.
	
	! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 11:23'!
testLabel
	self description label: 'Foo'.
	self assert: self description label = 'Foo'.
	! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 11:17'!
testMigrate
	| result |
	result := (MAString key: #value)
		migrate: self includedElement
		from: self description.
	self assert: (self description 
		toString: self includedElement) = result.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 16:09'!
testParseString
	self assert: (self description parseString: self nullElement) isNil.
	self assert: (self description parseString: self nullString) isNil.
	self assert: (self description includes: (description 
		parseString: (self description toString: self includedElement))).
	! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 11:24'!
testPriority
	self description priority: 123.
	self assert: self description priority = 123.! !

!MAAbstractElementTest methodsFor: 'testing-properties' stamp: 'lr 3/14/2005 10:23'!
testPropertiesAt
	description propertyAt: #foo put: 'bar'.
	
	self assert: (description propertyAt: #foo) = 'bar'.
	self should: [ description propertyAt: #bar ] raise: Error.
	! !

!MAAbstractElementTest methodsFor: 'testing-properties' stamp: 'lr 3/14/2005 10:24'!
testPropertiesAtIfAbsent
	description propertyAt: #foo put: 'bar'.
	
	self assert: (description propertyAt: #foo ifAbsent: [ 'baz' ]) = 'bar'.
	self assert: (description propertyAt: #bar ifAbsent: [ 'baz' ]) = 'baz'.
	! !

!MAAbstractElementTest methodsFor: 'testing-properties' stamp: 'lr 3/14/2005 10:25'!
testPropertiesIncludes
	description propertyAt: #foo put: 'bar'.
	
	self assert: (description propertyIncludes: #foo).
	self deny: (description propertyIncludes: #bar).
	! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 11:49'!
testRead
	self value: (other := self includedElement).
	self assert: (self description read: self) = other.
	
	self value: (other := self nullElement).
	self assert: (self description read: self) = self description class defaultDefault.! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 10:47'!
testReadSelector
	self assert: self description readSelector = #value.! !

!MAAbstractElementTest methodsFor: 'testing-settings' stamp: 'lr 3/14/2005 10:50'!
testReadonly
	self description beReadonly.
	self assert: self description readonly.
	self assert: self description isReadonly.
	self 
		should: [ self description write: self includedElement to: self ] 
		raise: Error.
	self assert: self value isNil.
	
	self description beWriteable.
	self deny: self description readonly.
	self deny: self description isReadonly.
	self 
		shouldnt: [ self description write: self includedElement to: self ] 
		raise: Error.
	self assert: self value notNil.! !

!MAAbstractElementTest methodsFor: 'testing-settings' stamp: 'lr 3/14/2005 10:53'!
testRequired
	self description beRequired.
	self assert: self description required.
	self assert: self description isRequired.
	self 
		should: [ self description write: nil to: self ] 
		raise: Error.
	self assert: self value isNil.
	self 
		shouldnt: [ self description write: self includedElement to: self ] 
		raise: Error.
	self deny: self value isNil.
	
	self description beOptional.
	self deny: self description required.
	self deny: self description isRequired.
	self 
		shouldnt: [ self description write: nil to: self ] 
		raise: Error.
	self assert: self value isNil.
	self 
		shouldnt: [ self description write: self includedElement to: self ] 
		raise: Error.
	self deny: self value isNil.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 10:49'!
testToString
	self assert: (self description toString: self includedElement) = self includedElement asString.! !

!MAAbstractElementTest methodsFor: 'testing-testing' stamp: 'lr 3/14/2005 11:13'!
testValidates
	self assert: (self description validates: self includedElement).
	self assert: (self description validates: self nullElement).
	
	self deny: (self description validates: self invalidElement).
	! !

!MAAbstractElementTest methodsFor: 'testing-settings' stamp: 'lr 3/14/2005 10:51'!
testVisible
	self description beVisible.
	self assert: self description visible.
	self assert: self description isVisible.
	
	self description beHidden.
	self deny: self description visible.
	self deny: self description isVisible.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 10:49'!
testWrite
	self description write: (other := self includedElement) to: self.
	self assert: self value = other.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 11:43'!
testWriteIncluded
	self
		should: [ self description write: self invalidElement to: self ]
		raise: MAValidationError.
	self assert: self value isNil.

	self
		shouldnt: [ self description write: self nullElement to: self ]
		raise: MAValidationError.
	self assert: self value isNil.
	
	self
		shouldnt: [ self description write: self includedElement to: self ]
		raise: MAValidationError.
	self deny: self value isNil.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 11:41'!
testWriteReadonly
	self description beReadonly.
	self
		should: [ self description write: self includedElement to: self ]
		raise: MAReadonlyError.
	self assert: self value isNil.
		
	self description beWriteable.
	self
		shouldnt: [ self description write: self includedElement to: self ]
		raise: MAReadonlyError.
	self assert: self value notNil.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 11:40'!
testWriteRequired
	self description beRequired.
	self
		should: [ self description write: nil to: self ]
		raise: MARequiredError.
	self assert: self value isNil.
		
	self description beOptional.
	self
		shouldnt: [ self description write: nil to: self ]
		raise: MARequiredError.
	self assert: self value isNil.! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 10:47'!
testWriteSelector
	self assert: self description writeSelector = #value:.! !

MAAbstractElementTest subclass: #MABinaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MABinaryTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:57'!
descriptionClass
	^MABinary! !

!MABinaryTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^ByteArray with: 1 with: 2 with: 3.! !

MAAbstractElementTest subclass: #MABooleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MABooleanTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:52'!
descriptionClass
	^MABoolean! !

!MABooleanTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^true! !

MAAbstractElementTest subclass: #MADateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MADateTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:57'!
descriptionClass
	^MADate! !

!MADateTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^Date current! !

MAAbstractElementTest subclass: #MANumberTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MANumberTest methodsFor: 'private' stamp: 'lr 3/11/2005 21:57'!
descriptionClass
	^MANumber! !

!MANumberTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^123! !

MAAbstractElementTest subclass: #MAOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAOptionsTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:33'!
descriptionClass
	^MAOptions! !

!MAOptionsTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^'Option 1'! !

!MAOptionsTest methodsFor: 'running' stamp: 'lr 3/14/2005 10:29'!
setUp
	super setUp.
	description 
		addOption: 'Option 1'; 
		addOption: 'Option 2'; 
		addOption: 'Option 3'.! !

MAAbstractElementTest subclass: #MAStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

MAStringTest subclass: #MAPasswordTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAPasswordTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:07'!
descriptionClass
	^MAPassword! !

!MAStringTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:07'!
descriptionClass
	^MAString! !

!MAStringTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:29'!
includedElement
	^'Hello World'! !

MAStringTest subclass: #MASymbolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MASymbolTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:08'!
descriptionClass
	^MASymbol! !

!MASymbolTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:29'!
includedElement
	^#foo! !

MAStringTest subclass: #MATextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATextTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:08'!
descriptionClass
	^MAText! !

MAAbstractElementTest subclass: #MATimeStampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATimeStampTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:08'!
descriptionClass
	^MATimeStamp! !

!MATimeStampTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:30'!
includedElement
	^TimeStamp current.! !

MAAbstractElementTest subclass: #MATimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATimeTest methodsFor: 'private' stamp: 'lr 3/11/2005 22:09'!
descriptionClass
	^MATime! !

!MATimeTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:30'!
includedElement
	^Time current.! !

TestCase subclass: #MAUtitliesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!
